package com.qizhen.healsphere.common.ai;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.web.client.RestTemplate;

import java.util.*;

public class BaidubceUtil {
    //private static String apiUrl = "https://aip.baidubce.com/rpc/2.0/ai_custom/v1/wenxinworkshop/chat/ernie-speed-pro-128k";
    private static String apiUrl = "https://aip.baidubce.com/rpc/2.0/ai_custom/v1/wenxinworkshop/chat/completions_pro";
    private static String apiKey = "JYVEqcv7o6IK7kgAw6fYkmZL";
 
    private static String apiSecret = "b15G2pqwVWIHDKHsAdN5yHouIzhe3J1H";
 
    private final static RestTemplate restTemplate = new RestTemplate();
    private final static ObjectMapper objectMapper = new ObjectMapper();
 
    public String getChatResponse(String userInput,String accessToken) {
        // 构建请求头
        Map<String, String> headers = new HashMap<>();
        headers.put("Content-Type", "application/json");
 
        // 构建请求体
        Map<String, Object> requestBody = new HashMap<>();
        Map messages = new HashMap();
        messages.put("role","user");
        messages.put("content",userInput);
        requestBody.put("messages", new Object[]{messages});
 
        // 发送POST请求
        Map<String, Object> responseMap = restTemplate.postForObject(
                apiUrl + "?access_token=" + accessToken,
                objectMapper.valueToTree(requestBody),
                Map.class,
                headers
        );

        // 处理响应
        if (responseMap != null && responseMap.containsKey("result")) {
            Object o = responseMap.get("result");
            if(o==null){
                return "";
            }
            return (String)o;
        }
        return "";
    }
 
    public static  String getAccessToken() {
        // 构建获取access_token的URL
        String tokenUrl = "https://aip.baidubce.com/oauth/2.0/token" +
                "?grant_type=client_credentials" +
                "&client_id=" + apiKey +
                "&client_secret=" + apiSecret;
 
        // 发送GET请求获取access_token
        Map<String, Object> tokenResponse = restTemplate.getForObject(
                tokenUrl,
                Map.class
        );
 
        // 从响应中提取access_token
        return (String) tokenResponse.get("access_token");
    }

    public static String fileName = "C:\\Users\\17664\\Desktop\\knowleges"+System.currentTimeMillis()+".xlsx";
    public static void main(String[] args) {
        // 获取access_token
        String accessToken = getAccessToken();
        String zhiling = "你是一个医学专业的关系抽取专家。需要从文本中提取带状疱疹的常伴发…有哪些?，请输出JSON数组格式的结果,不需要输出json之外的其他内容！如果有描述信息按如下要求输出：\n- 键 \"name\"：对应的的常伴发…有哪些?，字符串类型。\n- 键 \"description\"：对应的的常伴发…有哪些?的描述信息；如果没有，请使用空字符串。\n\n文本内容如下：\n\n";
        String des = "带状疱疹可引起皮肤出现红色斑点，逐渐变为水疱，沿一侧神经分布，伴有明显神经痛。疱疹破裂后，可形成糜烂面，并可能伴有细菌感染";
        System.out.println(new BaidubceUtil().getChatResponse(zhiling+des,accessToken));
  /*      String diseaseStr = "高血压； 冠心病； 房颤； 心力衰竭； 低血压； 心肌缺血； 心肌炎； 心绞痛； 窦性心动过缓； 急性心肌梗死； 高脂血症； 肺栓塞； 肺动脉高压； 动脉粥样硬化； 窦性心动过速； 卵圆孔未闭； 预激综合征； 心包积液； 扩张型心肌病； 室上性心动过速； 室间隔缺损； 肺水肿； 高同型半胱氨酸血症； 动脉导管未闭； 急性冠脉综合征； 肥厚型心肌病； 肺源性心脏病； 房室传导阻滞； 高血压危象； 二尖瓣关闭不全； 病态窦房结综合征； 主动脉瓣关闭不全； 二尖瓣狭窄； 高血压性心脏病； 室性心动过速； 二尖瓣脱垂； 心包炎； 早期复极综合征； 主动脉瓣狭窄； 慢性肺源性心脏病； 静脉血栓栓塞； 心脏肥大； 主动脉瘤； 心内膜炎； 心源性水肿； 心室颤动； 血脂异常； 应激性心肌病； 主动脉夹层； 心源性晕厥";
        String[] diseases = diseaseStr.split("；");
        for(String disease:diseases) {
            disease = disease.trim();
            System.out.println(new BaidubceUtil().getChatResponse("你是一个医学专家，想知道"+disease+"对应的ICD-10疾病名称和编码有哪些？请根据以下要求输出JSON数组格式的结果:\n" +
                    "不需要输出json之外的其他内容！\n" +
                    "- 键 \"name\"：疾病名称，字符串类型。\n" +
                    "- 键 \"code\"：对应的ICD10编码"));
        }*/
/*
        EasyExcel.write(fileName, Knowlege.class)
                .sheet("皮肤科")
                .doWrite(() -> {
                    // 分页查询数据
                    return getData(accessToken);
                });*/
    }

    private static List<Knowlege> getData(String accessToken) {
        String diseaseStr = "湿疹； 痤疮； 足癣/脚气； 脱发； 银屑病/牛皮癣； 特应性皮炎/AD； 甲真菌病； 带状疱疹； 梅毒； 获得性免疫缺陷综合征； 白癜风； 毛囊炎； 扁平疣； 汗疱疹； 脂肪瘤； 甲沟炎； 过敏性紫癜； 生殖器疱疹； 脂溢性皮炎； 阴虱； 玫瑰糠疹； 花斑癣； 股癣； 淋球菌感染； 神经性皮炎； 珍珠状阴茎丘疹； 日光性皮炎； 肛门瘙痒症； 丘疹性荨麻疹； 臭汗症； 丹毒； 系统性红斑狼疮； 疥疮； 鹅口疮； 斑秃； 疖； 玫瑰痤疮； 急性荨麻疹； 黑色素瘤； 胆碱能性荨麻疹； 尖锐湿疣； 慢性荨麻疹； 接触性皮炎； 肋间神经痛； 麻疹； 黄褐斑； 毛囊角化病； 传染性软疣； 白化病； 黑棘皮病";
        BaidubceUtil baidubceUtil = new BaidubceUtil();
        String propertyStr = "诊疗操作" +
                ",治疗方案" +
                ",诊断标准" +
                ",治疗目标" +
                ",治疗方式" +
                ",治疗相关检查" +
                ",致病原因" +
                ",治疗原则" +
                ",诊疗依据" +
                ",治疗场所" +
                ",子类" +
                ",治疗器械" +
                ",治疗药物" +
                ",转出重症病房标准" +
                ",诊断相关检查" +
                ",症状" ;

        String[] diseases = diseaseStr.split("；");
        String[] properties = propertyStr.split(",");
        List<Knowlege> list = new ArrayList<>();
        for(String disease:diseases) {
            disease = disease.trim();
/*            String icd10Json = baidubceUtil.getChatResponse("你是一个医学专家，想知道"+disease+"对应的ICD-10疾病名称和编码是什么？请根据以下要求输出JSON数组格式的结果:\n" +
                    "不需要输出json之外的其他内容！\n" +
                    "- 键 \"name\"：疾病名称，字符串类型。\n" +
                    "- 键 \"code\"：对应的ICD10编码",accessToken);
            String icd10 = filte(icd10Json);*/
            for (String property : properties) {
                property = property.trim();
                String q = "你是一个医生。想知道"+disease+"有哪些"+property+"?";
                String answer = baidubceUtil.getChatResponse(q,accessToken);
                String tiqu = "你是一个医学专业的关系抽取专家。需要从文本中提取"+disease+"的"+property+"，请输出JSON数组格式的结果,不需要输出json之外的其他内容！如果有描述信息按如下要求输出：" +
                        "\n" +
                        "- 键 \"name\"：对应的"+property+"，字符串类型。\n" +
                        "- 键 \"description\"：对应的"+property+"的描述信息；如果没有，请使用空字符串。" +
                        "\n\n文本内容如下：\n\n" +answer;
                String chatResponse = baidubceUtil.getChatResponse(tiqu,accessToken);
                chatResponse = filte(chatResponse);
                Knowlege knowlege = new Knowlege();
                knowlege.setEntity(disease);
                knowlege.setProperty(property);
                knowlege.setValue(chatResponse);
                knowlege.setAnswer(answer);
                //knowlege.setRefenrece(icd10);
                list.add(knowlege);
            }
        }
        return list;
    }

    private static String filte(String chatResponse) {
        if(chatResponse.startsWith("```json")){
            chatResponse = chatResponse.substring(7);
        }
        if(chatResponse.endsWith("```")){
            chatResponse = chatResponse.substring(0, chatResponse.length()-3);
        }
        return chatResponse;
    }


}
