package com.qizhen.healsphere.common.hyw.hbrmHospital;

import com.qizhen.healsphere.common.pipeline.ExcelPipeline;
import org.apache.commons.lang3.StringUtils;
import org.springframework.util.CollectionUtils;
import us.codecraft.webmagic.Page;
import us.codecraft.webmagic.Site;
import us.codecraft.webmagic.Spider;
import us.codecraft.webmagic.processor.PageProcessor;
import us.codecraft.webmagic.selector.Selectable;

import java.util.Arrays;
import java.util.List;

/**
 * @author 410775541@qq.com <br>
 * @since 0.5.1
 */
public class HubeiMainDoctorNewPageProcessor implements PageProcessor {

    private Site site = Site.me().setCycleRetryTimes(5).setRetryTimes(5).setSleepTime(500).setTimeOut(3 * 60 * 1000)
            .setUserAgent("Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/130.0.0.0 Safari/537.36")
            .addHeader("Accept", "*/*")
            .addHeader("Accept-Language", "zh-CN,zh;q=0.9,en-US;q=0.8,en;q=0.7")
            .setCharset("UTF-8");
    String[] wordTimeArray = { "周一上午","周一下午", "周二上午","周二下午", "周三上午","周三下午", "周四上午","周四下午", "周五上午","周五下午", "周六上午","周六下午","周日上午","周日下午"};

    @Override
    public void process(Page page) {
//        List<String> all = page.getHtml().xpath("//div[@class='Contentboxnav']//a/@href").all();
//        Set<String> set = new HashSet<>(all);
//        System.out.println(all);
//        page.addTargetRequests(new ArrayList<>(set));
        List<String> relativeUrl = page.getHtml().xpath("//div[@class='moredr']//a/@href").all();
        page.addTargetRequests(relativeUrl);

        List<String> doctorUrl = page.getHtml().xpath("//div[@class='dr-content']//div[@class='dr_list']//a/@href").all();
        page.addTargetRequests(doctorUrl);

        String doctorName =  page.getHtml().xpath("//div[@class='drout']//div[@class='dr_title']/span/text()").get();
        if (StringUtils.isNotEmpty(doctorName)) {
            page.putField("doctor_name",doctorName);
            page.putField("header_pic",page.getHtml().xpath("//div[@class='drout']//div[@class='dr_img']/img/@src").get());
            page.putField("position", page.getHtml().xpath("//div[@class='drout']//div[@class='drinoright pull-right']/div[3]//p/tidyText()"));

            String desc1 = page.getHtml().xpath("//div[@class='drout']//div[@class='drinoright pull-right']/div[5]//tidyText()").get();

            String desc2 = page.getHtml().xpath("//div[@class='drout']//div[@class='drinoright pull-right']/div[6]//tidyText()").get();

            String desc = "";
            if (StringUtils.isNotEmpty(desc1) && StringUtils.isNotEmpty(desc2)) {
                desc = desc1 + "\n" + desc2;
            }else if (StringUtils.isNotEmpty(desc1)) {
                desc = desc1;
            }else if (StringUtils.isNotEmpty(desc2)) {
                desc = desc2;
            }

            page.putField("des",desc);
            page.putField("good_at",page.getHtml().xpath("//div[@class='drout']//div[@class='drinoright pull-right']/div[4]//tidyText()").replace("诊疗专长","").replace("\n",""));
            page.putField("dept_name",page.getHtml().xpath("//div[@class='drout']//div[@class='dr_title']/i[1]/a/text()"));
            page.putField("title",page.getHtml().xpath("//div[@class='drout']//div[@class='dr_title']/i[2]/text()"));

            List<Selectable> nodes = page.getHtml().xpath("/html/body/div[1]/div[2]/table/tbody/tr/").nodes();
            String wordTime= "";
            if(!CollectionUtils.isEmpty(nodes)) {
                for (int i = 0; i < nodes.size(); i++) {
                    if(i==0){
                        continue;
                    }
                    //排版td节点下还有节点就是要坐诊
                    String string = nodes.get(i).toString();
                    if (string.contains("<i")) {
                        wordTime+=wordTimeArray[i-1]+"、";
                    }
                }
            }
            if(StringUtils.isNotEmpty(wordTime)) {
                page.putField("word_time", wordTime.substring(0, wordTime.length() - 1));
            }
        }else {
            page.setSkip(true);
        }

    }

    @Override
    public Site getSite() {
        return site;
    }

    public static void main(String[] args) {
        List<String> titles = Arrays.asList("doctor_name","header_pic","title","position","des","good_at","dept_name","word_time");
        Spider.create(new HubeiMainDoctorNewPageProcessor()).
                addUrl("https://www.rmhospital.com/dept/yxw/doctorlist.html").
//                addPipeline(new FilePipeline("D:\\webmagic\\")).
//                addPipeline(new ConsolePipeline()).
                addPipeline(new ExcelPipeline("D:\\webmagic\\湖北省人民医院主院区","湖北省人民医院主院区医生列表",titles)).
                thread(1).
                run();
    }
}
