package com.qizhen.healsphere.repository.neo4j.entity;

import org.springframework.data.neo4j.core.schema.GeneratedValue;
import org.springframework.data.neo4j.core.schema.Id;
import org.springframework.data.neo4j.core.schema.Node;
import org.springframework.data.neo4j.core.schema.Relationship;

import java.util.HashSet;
import java.util.Set;

@Node("疾病名称")
public class Disease {

    @Id
    @GeneratedValue
    private Long id;

    private String name;

    private String icd10;


    public Disease() {// 从 Neo4j API 2.0.5开始需要无参构造函数

    }

    public Disease(String name, String icd10) {
        this.name = name;
        this.icd10 = icd10;
    }
    
    
    @Relationship(type = "疾病相关诊疗操作")
    public Set<Zlcz> zlczs;

    public void addZlcz(Zlcz zlcz) {
        if (zlczs == null) {
            zlczs = new HashSet<>();
        }
        zlczs.add(zlcz);
    }
    
    
    @Relationship(type = "疾病相关治疗方案")
    public Set<Zlfa> zlfas;

    public void addZlfa(Zlfa zlfa) {
        if (zlfas == null) {
            zlfas = new HashSet<>();
        }
        zlfas.add(zlfa);
    }

    @Relationship(type = "疾病相关诊断标准")
    public Set<Zdbz> zdbzs;

    public void addZdbz(Zdbz zdbz) {
        if (zdbzs == null) {
            zdbzs = new HashSet<>();
        }
        zdbzs.add(zdbz);
    }


    @Relationship(type = "疾病相关治疗目标")
    public Set<Zlmb> zlmbs;

    public void addZlmb(Zlmb zlmb) {
        if (zlmbs == null) {
            zlmbs = new HashSet<>();
        }
        zlmbs.add(zlmb);
    }

    @Relationship(type = "疾病相关治疗方式")
    public Set<Zlfs> zlfss;

    public void addZlfs(Zlfs zlfs) {
        if (zlfss == null) {
            zlfss = new HashSet<>();
        }
        zlfss.add(zlfs);
    }


    @Relationship(type = "疾病相关治疗相关检查")
    public Set<Zlxgjc> zlxgjcs;

    public void addZlxgjc(Zlxgjc zlxgjc) {
        if (zlxgjcs == null) {
            zlxgjcs = new HashSet<>();
        }
        zlxgjcs.add(zlxgjc);
    }

    @Relationship(type = "疾病相关致病原因")
    public Set<Zbyy> zbyys;

    public void addZbyy(Zbyy zbyy) {
        if (zbyys == null) {
            zbyys = new HashSet<>();
        }
        zbyys.add(zbyy);
    }


    @Relationship(type = "疾病相关治疗原则")
    public Set<Zlyz> zlyzs;

    public void addZlyz(Zlyz zlyz) {
        if (zlyzs == null) {
            zlyzs = new HashSet<>();
        }
        zlyzs.add(zlyz);
    }

    @Relationship(type = "疾病相关诊疗依据")
    public Set<Zlyj> zlyjs;

    public void addZlyj(Zlyj zlyj) {
        if (zlyjs == null) {
            zlyjs = new HashSet<>();
        }
        zlyjs.add(zlyj);
    }


    @Relationship(type = "疾病相关治疗场所")
    public Set<Zlcs> zlcss;

    public void addZlcs(Zlcs zlcs) {
        if (zlcss == null) {
            zlcss = new HashSet<>();
        }
        zlcss.add(zlcs);
    }

    @Relationship(type = "疾病相关子类")
    public Set<Zl> zls;

    public void addZl(Zl zl) {
        if (zls == null) {
            zls = new HashSet<>();
        }
        zls.add(zl);
    }


    @Relationship(type = "疾病相关治疗器械")
    public Set<Zlqx> zlqxs;

    public void addZlqx(Zlqx zlqx) {
        if (zlqxs == null) {
            zlqxs = new HashSet<>();
        }
        zlqxs.add(zlqx);
    }

    @Relationship(type = "疾病相关治疗药物")
    public Set<Zlyw> zlyws;

    public void addZlyw(Zlyw zlyw) {
        if (zlyws == null) {
            zlyws = new HashSet<>();
        }
        zlyws.add(zlyw);
    }


    @Relationship(type = "疾病相关转出重症病房标准")
    public Set<Zczzbfbz> zczzbfbzs;

    public void addZczzbfbz(Zczzbfbz zczzbfbz) {
        if (zczzbfbzs == null) {
            zczzbfbzs = new HashSet<>();
        }
        zczzbfbzs.add(zczzbfbz);
    }

    @Relationship(type = "疾病相关诊断相关检查")
    public Set<Zdxgjc> zdxgjcs;

    public void addZdxgjc(Zdxgjc zdxgjc) {
        if (zdxgjcs == null) {
            zdxgjcs = new HashSet<>();
        }
        zdxgjcs.add(zdxgjc);
    }


    @Relationship(type = "疾病相关症状")
    public Set<Zz> zzs;

    public void addZz(Zz zz) {
        if (zzs == null) {
            zzs = new HashSet<>();
        }
        zzs.add(zz);
    }
    
   
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getIcd10() {
        return icd10;
    }

    public void setIcd10(String icd10) {
        this.icd10 = icd10;
    }
}
