/*
 * Copyright 2013-2018 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.qizhen.healsphere.web;

import com.qizhen.healsphere.web.param.User;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * @author <a href="mailto:chenxilzx1@gmail.com">theonefx</a>
 */
@Controller
//@Api(value = "用户管理", tags = { "用户管理相关API" })
public class BasicController {

    // http://127.0.0.1:8080/hello?name=lisi
    @RequestMapping("/hello")
    @ResponseBody
    public String hello(@RequestParam(name = "name", defaultValue = "unknown user") String name) {
        return "Hello " + name;
    }

    // http://127.0.0.1:8080/user
    @RequestMapping("/user")
    @ResponseBody
    public User user() {
        User user = new User();
        user.setName("theonefx");
        user.setAge(666);
        return user;
    }

    // http://127.0.0.1:8080/save_user?name=newName&age=11
    @RequestMapping("/save_user")
    @ResponseBody
    public String saveUser(@RequestBody @Valid User u) {
        return "user will save: name=" + u.getName() + ", age=" + u.getAge();
    }

    // http://127.0.0.1:8080/html
    @RequestMapping("/html")
    public String html() {
        return "index.html";
    }

    @ModelAttribute
    public void parseUser(@RequestParam(name = "name", defaultValue = "unknown user") String name
            , @RequestParam(name = "age", defaultValue = "12") Integer age, User user) {
        user.setName("zhangsan");
        user.setAge(18);
    }

    public static void main(String[] args) {
        String ss = "医保版ICD-10编码是什么?" +
                ",的七巧板医学术语集概念ID是是什么?" +
                ",的并发症有哪些?" +
                ",的常伴发…有哪些?" +
                ",的常见并发症有哪些?" +
                ",的病理过程有哪些病理过程?" +
                ",的发病机制有哪些?" +
                ",在器官、组织或细胞水平上的形态学异常变化有哪些（如“心脏脓肿”的形态学异常改变是“脓肿”，“眼睑下垂”的形态学异常改变是“下垂”）?" +
                ",的临床病情监测措施有哪些?" +
                ",的临床预警指标有哪些?" +
                ",的早期临床预警指标有哪些?" +
                ",的病因有哪些?" +
                ",发生于…期间或诱发因素有哪些?" +
                ",的危险因素有哪些?" +
                ",如果该病是遗传性疾病，遗传方式有哪些?" +
                ",可能引起本病的相关遗传基因哪些?";
    }
}
