package com.qizhen.healsphere;

import cn.hutool.json.JSONUtil;
import com.qizhen.healsphere.repository.neo4j.BaseNodeRepository;
import com.qizhen.healsphere.repository.neo4j.BasePropertyRepository;
import com.qizhen.healsphere.repository.neo4j.BaseRelationshipRepository;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RunWith(SpringRunner.class)
@ComponentScan(basePackages = {"com.qizhen.healsphere.model","com.qizhen.healsphere.repository"})
@SpringBootTest
public class DiseaseTests {
    @Autowired
    BaseNodeRepository baseNodeRepository;

    @Autowired
    BaseRelationshipRepository baseRelationshipRepository;

    @Autowired
    BasePropertyRepository basePropertyRepository;


    @Test
    public void contextLoads() {}

    @Test
    public void testCrudNodeDemo() {

        Map<String,Object> map = new HashMap<>();
        map.put("name","糖尿病");
        map.put("desc","这属于一种慢性病，尿液含糖量高");
        map.put("诱因","吃的糖太多了");
        map.put("治疗方式","打胰岛素");
        String label = "疾病名称";
        Map<String, Object> node = baseNodeRepository.createNode(label, map);
        System.out.println(JSONUtil.toJsonStr(node));

        Map<String,Object> map1 = new HashMap<>();
        map1.put("name","尿液泡沫多");
        map1.put("desc","常见于肾脏不好的患者");
        String label1 = "主要症状";
        Map<String, Object> node1 = baseNodeRepository.createNode(label1, map1);
        System.out.println(JSONUtil.toJsonStr(node1));

//        Map<String,Object> list = baseNodeRepository.findNode(label, "糖尿病");
//        System.out.println(JSONUtil.toJsonStr(list));

//        Long id = 24L;
//        baseNodeRepository.updateNode(label,id,map);

//        list = baseNodeRepository.findNode(label, "糖尿病");
//        System.out.println(JSONUtil.toJsonStr(list));

//        baseNodeRepository.deleteNode(label,id);



    }

    @Test
    public void testCrudRelationshipDemo() {

        String startLabel = "疾病名称";
        Long startId = 1L;

        String endLabel = "主要症状";
        Long endId = 2L;

        String relationShipType = "疾病相关主要症状";

        Map<String,Object> map = new HashMap<>();

        map.put("描述","这是疾病和症状的关系");


//        baseNodeRepository.createRelationship(startLabel,startId,endLabel,endId,relationShipType,map);


//        baseRelationshipRepository.deleteRelationship(startLabel,startId,endLabel,endId,relationShipType);
//        List<String> relationshipNames = baseRelationshipRepository.findRelationshipNames("111");
//        System.out.println(JSONUtil.toJsonStr(relationshipNames));

//        baseRelationshipRepository.updateRelationship("疾病症状之间的关系111","疾病症状之间的关系222333");
        baseRelationshipRepository.deleteRelationship(startLabel,startId,endLabel,endId,"疾病症状之间的关系222333");


    }

    @Test
    public void testCrudPropertyDemo() {

        String label = "疾病名称";
        Long nodeId = 1L;
//        Map<String,Object> map = new HashMap<>();
//        map.put("prop1","测试属性1");
//        map.put("prop2","测试属性2");

//        Map<String, Object> objectMap = basePropertyRepository.createProperty(label, nodeId, map);
//        System.out.println(JSONUtil.toJsonStr(objectMap));

//        Map<String, Object> stringObjectMap = basePropertyRepository.updateProperty(label, nodeId, "prop1", "prop3", "最新的属性");
//        System.out.println(JSONUtil.toJsonStr(stringObjectMap));

        Map<String, Object> stringObjectMap1 = basePropertyRepository.deleteProperty(label, nodeId, "prop2");
        System.out.println(JSONUtil.toJsonStr(stringObjectMap1));


    }

}

